/*************************************************************************
This code is from Dynamic Web Coding 
at http://www.dyn-web.com/
Copyright 2002 by Sharon Paine 
See Terms of Use at http://www.dyn-web.com/bus/terms.html
Permission granted to use this code 
as long as this entire notice is included.
*************************************************************************/
/*************************************************************************
Code Modified by: Solomon Closson 2008
Also Known as: SoLoGHoST at http://thehobbylounge.com/
*************************************************************************/


var slide_in_speed = 600;
var slide_out_speed = 500;
var glideLyrs = new Array();

function initGlideLayers() {

if (bgType == "small") {
  glideLyrs[0] = new dynObj('glideDiv0', 0, -6);
  glideLyrs[1] = new dynObj('glideDiv1', 0, 9);
  glideLyrs[2] = new dynObj('glideDiv2', 0, 9);
} else {
  glideLyrs[0] = new dynObj('glideDiv0', 0, 9);
  glideLyrs[1] = new dynObj('glideDiv1', 0, 24);
  glideLyrs[2] = new dynObj('glideDiv2', 0, 24);
}
  for (var i=0; glideLyrs[i]; i++) {
	glideLyrs[i].xOff = -(glideLyrs[i].w + 10);
	glideLyrs[i].shiftTo( glideLyrs[i].xOff, glideLyrs[i].y );
	glideLyrs[i].show();
  }
}

var curGlideLyr = "first";

function slideEm(id, xNum) {
  var oldLyr, newLyr;

glideLyrs[0].show();

if ((xNum == 1) || (xNum == 2))
{
if ((id == "UnPage2") || (id == "Page2")) {
		glideLyrs[0].shiftTo(10, glideLyrs[0].y);
		glideLyrs[0].onSlideEnd = function() { 
			glideLyrs[0].slideTo(10, null, slide_in_speed, -1);
    			glideLyrs[1].slideTo(0, null, slide_in_speed, -1);
			this.onSlideEnd = function() { if (this.el) this.el = null } 
		}
		glideLyrs[0].slideTo(glideLyrs[0].xOff, null, slide_out_speed, -1);
		glideLyrs[2].slideTo(glideLyrs[2].xOff, null, slide_out_speed, -1);

		curGlideLyr = "glideDiv0";
return;
} else if ((id == "UnPage1") || (id == "Page1")) {
		glideLyrs[0].shiftTo(10, glideLyrs[0].y);
		glideLyrs[0].onSlideEnd = function() { 
			glideLyrs[0].slideTo(10, null, slide_in_speed, -1);
    			glideLyrs[2].slideTo(0, null, slide_in_speed, -1);
			this.onSlideEnd = function() { if (this.el) this.el = null } 
		}
		glideLyrs[0].slideTo(glideLyrs[0].xOff, null, slide_out_speed, -1);
		glideLyrs[1].slideTo(glideLyrs[1].xOff, null, slide_out_speed, -1);

		curGlideLyr = "glideDiv0";
return;
}
} else if ((xNum == 0) || (xNum == 3)) {

if (curGlideLyr == id) { 
   if (xLock == 0) {
	oldLyr = dynObj.getInstance(curGlideLyr);
	oldLyr.slideTo(oldLyr.xOff, null, slide_out_speed, -1);
	exitTitle = "";
    	curGlideLyr = id;
	xLock = 1;
    } else if (xLock == 1) {
    	newLyr = dynObj.getInstance(id);
    	newLyr.slideTo(10, null, slide_in_speed, -1);
	exitTitle = "Yes";
	curGlideLyr = id;
	xLock = 0;
    }
    System.Gadget.Settings.write("xLock", xLock);
return; 
}

if ((curGlideLyr == "") || (curGlideLyr == "first")) {

if (xPage == 1)  {
	glideLyrs[2].shiftTo(glideLyrs[2].xOff, glideLyrs[2].y);
	glideLyrs[1].shiftTo(0, glideLyrs[1].y);
} else if (xPage == 2) {
	glideLyrs[1].shiftTo(glideLyrs[1].xOff, glideLyrs[1].y);
	glideLyrs[2].shiftTo(0, glideLyrs[2].y);
}

	if (curGlideLyr == "first") {
		if (System.Gadget.Settings.read("autoLock") == "Off") {
			if (xLock == 0) {
    				newLyr = dynObj.getInstance(id);
    				newLyr.slideTo(10, null, slide_in_speed, -1);
				exitTitle = "Yes";
				curGlideLyr = id;
				return;
			} else {	
				curGlideLyr = "glideDiv0";
				slideEm('glideDiv0',0);	
				curGlideLyr = id;
				return;
			}
		}
		newLyr = dynObj.getInstance(id);
		newLyr.slideTo(10, null, slide_in_speed, -1);
		exitTitle = "Yes";
		curGlideLyr = id;
		return;
	} else 	if (curGlideLyr != "first") {
			xLock = (xLock == 0)?1:0;
		System.Gadget.Settings.write("xLock", xLock);
	}

  }
	curGlideLyr = id;
}
}

dynObj.holder = {}; 
function dynObj(id,x,y,w,h) {
  var el = dynObj.getElemRef(id);
  if (!el) return;  this.id = id; 
  dynObj.holder[this.id] = this; this.animString = "dynObj.holder." + this.id;
  var px = window.opera? 0: "px";
	this.x = x || 0;	if (x) el.style.left = this.x + px;
	this.y = y || 0;	if (y) el.style.top = this.y + px;
	this.w = w || el.offsetWidth || 0;	this.h = h || el.offsetHeight || 0;
	if (w) el.style.width = w + px; if (h) el.style.height = h + px;
}

dynObj.getElemRef = function(id) { 
  var el = document.getElementById? document.getElementById(id): null;
  return el;
} 

dynObj.getInstance = function(id) {
  var obj = dynObj.holder[id];
  if (!obj) obj = new dynObj(id);
  else if (!obj.el) obj.el = dynObj.getElemRef(id);
  return obj;
}

dynObj.prototype.shiftTo = function(x,y) {
  var el = this.el? this.el: dynObj.getElemRef(this.id)? dynObj.getElemRef(this.id): null;
  if (el) {
    if (x != null) el.style.left = (this.x = x) + "px";
    if (y != null) el.style.top = (this.y = y) + "px";
  }
}

dynObj.prototype.shiftBy = function(x,y) { this.shiftTo(this.x+x, this.y+y); }

dynObj.prototype.show = function() { 
  var el = this.el? this.el: dynObj.getElemRef(this.id)? dynObj.getElemRef(this.id): null;
  if (el) el.style.visibility = "visible"; 
}
dynObj.prototype.hide = function() { 
  var el = this.el? this.el: dynObj.getElemRef(this.id)? dynObj.getElemRef(this.id): null;
  if (el) el.style.visibility = "hidden"; 
}


var dw_Bezier = { 
  B1: function (t) { return t*t*t },
  B2: function (t) { return 3*t*t*(1-t) },
  B3: function (t) { return 3*t*(1-t)*(1-t) },
  B4: function (t) { return (1-t)*(1-t)*(1-t) },
  getValue: function (percent,startVal,endVal,c1,c2) {
    return endVal * this.B1(percent) + c2 * this.B2(percent) + c1 * this.B3(percent) + startVal * this.B4(percent);
  }
}

dw_Animation = {
  instances: [],
  add: function(fp) {
    this.instances[this.instances.length] = fp;
  	if (this.instances.length == 1) this.timerID = window.setInterval("dw_Animation.control()", 10);
  },
  
  remove: function(fp) {
    for (var i = 0; this.instances[i]; i++) {
  		if (fp == this.instances[i]) {
  			this.instances = this.instances.slice(0,i).concat( this.instances.slice(i+1) );
  			break;
  		}
  	}
  	if (this.instances.length == 0) {
  		window.clearInterval(this.timerID);	this.timerID = null;
  	}
  },
  
  control: function() {
    for (var i = 0; this.instances[i]; i++) {
  		if (typeof this.instances[i] == "function" ) this.instances[i]();
      else eval(this.instances[i]);
    }
  }
}


dynObj.prototype.slideTo = function (destX,destY,slideDur,acc,endFn) { 
  if (!document.getElementById) return;
  this.slideDur = slideDur || .0001; var acc = -acc || 0;
  if (endFn) this.onSlideEnd = endFn;
  if (destX == null) this.destX = this.x;	else this.destX = destX;
  if (destY == null) this.destY = this.y; else this.destY = destY;
  this.startX = this.x; this.startY = this.y;
	this.st = new Date().getTime();
  this.xc1 = this.x + ( (1+acc) * (this.destX-this.x)/3 );
	this.xc2 = this.x + ( (2+acc) * (this.destX-this.x)/3 );
  this.yc1 = this.y + ( (1+acc) * (this.destY-this.y)/3 );
	this.yc2 = this.y + ( (2+acc) * (this.destY-this.y)/3 );
	this.sliding = true;
  this.onSlideStart();
  dw_Animation.add(this.animString + ".doSlide()");
}

dynObj.prototype.doSlide = function() {
	if (!this.sliding) return;	
	var elapsed = new Date().getTime() - this.st;
	if (elapsed < this.slideDur) {
    var x = dw_Bezier.getValue(elapsed/this.slideDur, this.startX, this.destX, this.xc1, this.xc2);
    var y = dw_Bezier.getValue(elapsed/this.slideDur, this.startY, this.destY, this.yc1, this.yc2);
		this.shiftTo( Math.round(x) ,Math.round(y) );
		this.onSlide();
	} else {
    dw_Animation.remove(this.animString + ".doSlide()");
		this.shiftTo(this.destX,this.destY);
		this.onSlide();
		this.sliding = false;
		this.onSlideEnd();
	}
}

dynObj.prototype.slideBy = function(dx,dy,slideDur,acc,endFn) {
	var destX=this.x+dx; var destY=this.y+dy;
	this.slideTo(destX,destY,slideDur,acc,endFn);
}

dynObj.prototype.onSlideStart = function () {}
dynObj.prototype.onSlide = function () {}
dynObj.prototype.onSlideEnd = function () { if (this.el) this.el = null; }